package com.docus.webservice.handler;


import com.alibaba.fastjson.JSON;
import com.docus.webservice.dto.SelectColumn;
import com.docus.webservice.enums.Codes;
import com.docus.webservice.entity.TBasic;
import com.docus.webservice.entity.TBasicSub;
import com.docus.webservice.mapper.TBasicMapper;
import com.docus.webservice.mapper.TBasicSubMapper;
import com.docus.webservice.utils.JsonUtils;
import com.docus.webservice.utils.ResultUtils;
import com.docus.webservice.utils.XmlUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;

import javax.jws.WebService;
import java.io.ByteArrayInputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@WebService
public class TBasicWebService implements ITBasicWebService {

    @Autowired
    private TBasicMapper tBasicMapper;

    @Autowired
    private TBasicSubMapper tBasicSubMapper;


    @Override
    public String savaAndSub(String tbasic) {
        XmlUtils xmlUtils = null;
        String resXml;
        try {
            //解析xml
            xmlUtils = new XmlUtils(new ByteArrayInputStream(tbasic.getBytes("UTF-8")));
            //解析json映射文件
            String json = JsonUtils.readJsonFile(Codes.JSON_ADDRESS.getMessage());
            Map jsonMap = JSON.parseObject(json, Map.class);
            HashMap<String, Object> tBasicMap = new HashMap<>();
            HashMap<String, Object> tBasicSubMap = new HashMap<>();
            List<SelectColumn> selectColumns = JSON.parseArray(String.valueOf(jsonMap.get("selectColumns")), SelectColumn.class);
            String value;
            for (SelectColumn selectColumn : selectColumns) {
                try {
                    value = String.valueOf(xmlUtils.getElementText(selectColumn.getQualityColumn()));
                }catch (RuntimeException e){
                    String message = e.getMessage();
                    System.out.println(message);
                    return ResultUtils.fail(message);
                }
                if (StringUtils.isBlank(value)) {
                    if (selectColumn.getByNull() == 0) {
                        return ResultUtils.fail(selectColumn.getQualityColumn() + " 字段不能为空值");
                    } else {
                        continue;
                    }
                } else {
                    if (selectColumn.getTableName().equals("t_basic")) {
                        tBasicMap.put(selectColumn.getColumnName(), value);
                    }
                    if (selectColumn.getTableName().equals("t_basic_sub")) {
                        tBasicSubMap.put(selectColumn.getColumnName(), value);
                    }
                }
            }
            //处理业务
            TBasic tBasic = new TBasic();

            int insert;
            if (tBasicMap != null && tBasicMap.size() > 0) {
                tBasic=JsonUtils.map2bean(tBasicMap,TBasic.class);
//                insert = tBasicMapper.insert(tBasic);
//                if (insert <= 0) {
//                    return ResultUtils.fail("数据库执行出错，请重试");
//                }
                TBasicSub tBasicSub = new TBasicSub();
//                BeanUtils.copyProperties(tBasicSubMap, tBasicSub);
                tBasicSub=JsonUtils.map2bean(tBasicSubMap,TBasicSub.class);
                tBasicSub.setPatientId(tBasic.getPatientId());
//                insert = tBasicSubMapper.insert(tBasicSub);
//                if (insert <= 0) {
//                    return ResultUtils.fail("数据库执行出错，请重试");
//                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            return ResultUtils.fail();
        }
        return ResultUtils.success().asXML();
    }
}
